! This example creates a dataset with one
! table and one array.
! The table will have block number 0,
! and the array will have block number 1
subroutine displayBlockNumber( thisBlock )
  use dal

  implicit none

  type(BlockT) thisBlock

  write(*,*) "The block with name ", name( thisBlock ), "has number "
  write(*,*) blockNumber( parent( thisBlock ), name( thisBlock ) )

end subroutine displayBlockNumber

program example_blocknumber
  use dal

  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr
  integer, dimension(3), parameter :: s = (/ 3,4,2 /)
   
  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"table",10);
  arr = addArray(set, "array", INTEGER32, dimensions=s )

  call displayBlockNumber( block( tab ) )
  call displayBlockNumber( block( arr ) )

  call release(set)
   
end program example_blockNumber
