! In this example a dataset is created, with
! three tables.
! The created datanew is then copied to a new dataset.
! A simple loop then iterates over the new
! dataset's ! blocks (a table may be treated as a block)
! then displays the name of ! each table, and adds a comment
! to each block (table).
program example_copydataset

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(BlockT) blk
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"first table",100)
  tab = addTable(set,"second table",1000)
  tab = addTable(set,"third table",10000)

  call release(set)

  call copyDataSet( "test.dat", "test1.dat" )

  set = dataSet("test1.dat",READ)
  do i = 0, numberOfBlocks( set ) - 1
    blk = block( set, i, MODIFY )
    write(*,*) name( blk )
    call addComment( blk, "Copied from test.dat" )
  end do

  call release(set)

end program example_copydataset
