! This example shows how int16 attributes are used.
! The program creates a dataset containing two int16 attributes,
! together with a table containing two int16 attributes.
! The attributes are then accessed, by name, with
! the int16Attribute() function.
! Also, it is shown how to access the attributes by position.
program example_int16attribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"int1",1,"int comment")
  call setAttribute(set,"int2",2,"int comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"int1",3,"int comment")
  call setAttribute(tab,"int2",4,"int comment")

  write(*,*) int16Attribute( set, "int1" ) ! output '1'
  write(*,*) int16Attribute( set, "int2" ) ! output '2'
  write(*,*) int16Attribute( tab, "int1" ) ! output '3'
  write(*,*) int16Attribute( tab, "int2" ) ! output '4'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) int16Attribute( att ) ! output the sequence 1, 2
  end do

  call release(set)

end program example_int16attribute
