! This example shows how to use the keepDataSet
! subroutine
program example_keepdiscarddataset

  use dal
  
  implicit none

  type(DataSetT) set

  set = dataSet("test.dat",CREATE)
  call release(set)		  ! The dataset will be released from memory

  call keepDataSet("test.dat")	  ! Tell the dataset server not to discard
  				  ! the dataset with name "test.dat"

  set = dataSet("test.dat",READ)
  call release(set)		  ! The dataset will not be released from memory

  set = dataSet("test.dat",READ)  ! The dataset is already in memory, so this
  				  ! operation has virtually no overhead.

  call release(set)		  ! The dataset will not be released from memory
  call discardDataSet("test.dat") ! Tell the dataset server to discard and
  				  ! release the dataset with name "test.dat"

end program example_keepdiscarddataset
