! This example shows how the numberOfBlocks interface
! is used.
program example_numberofblocks

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(BlockT) blk
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"table1",10)
  tab = addTable(set,"table2",100)
  tab = addTable(set,"table3",1000)

  write(*,*) numberOfBlocks( set ) ! 3 blocks

  ! For each block, display the name, and
  ! add a comment.
  do i=0,numberOfBlocks( set ) - 1
    blk = block( set, i, MODIFY )
    write(*,*) name( blk )
    call addComment( blk, "A table comment" )
  end do

  call release(set)

end program example_numberofblocks
