! In this example add dataset is created (opened) containing
! a table with 2 columns of two vector arrays.
!
! The second array has the same data type as the first; this
! is ensured by using the arrayDataType() function to determine
! the data type of the first array.
!
! The columns are then  initialised, on a row-by-row
! basis (i.e. accessing the column's data cell-by-cell),
! before the dataset is released (closed).
program example_cellvectordata

  use dal
  use errorhandling

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col1, col2
  real(kind=SINGLE), dimension(:), pointer :: c1, c2
  integer, dimension(1), parameter :: s = (/ 3 /)
  integer :: i,m,n

  ! create a set
  set = dataSet("test.dat",CREATE)
  tab = addTable(set, "table", 100, "table comment" )
  col1 = addColumn( tab, "column1", REAL32, "km", s, "column comment" )
  col2 = addColumn( tab, "column2", columnDataType( col1 ), "km", s, "column comment" )

  ! fill with unique numbers

  n = 0
  do m=0,numberOfRows(tab) - 1
    c1 => real32VectorData(col1,m)
    c2 => real32VectorData(col2,m)
    do i=0,2 
      c1(i) = n
      c2(i) = c1(i)
      n = n + 1
    end do
  end do

  call release(col1)
  call release(col2)
  call release(set)

end program example_cellvectordata
