! This example shows how real64 attributes are used.
! The program creates a dataset containing two real64 attributes,
! together with a table containing two real64 attributes.
! The attributes are then accessed, by name, with
! the real64Attribute() function.
! Also, it is shown how to access the attributes by position.
program example_real64attribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"real1",1.0,"real comment")
  call setAttribute(set,"real2",2.0,"real comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"real1",3.0,"real comment")
  call setAttribute(tab,"real2",4.0,"real comment")

  write(*,*) real64Attribute( set, "real1" ) ! output '1.0'
  write(*,*) real64Attribute( set, "real2" ) ! output '2.0'
  write(*,*) real64Attribute( tab, "real1" ) ! output '3.0'
  write(*,*) real64Attribute( tab, "real2" ) ! output '4.0'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) real64Attribute( att ) ! output the sequence 1.0, 2.0
  end do

  call release(set)

end program example_real64attribute
