! This example shows how the seek functions
! are used.
! This subroutine will dispaly the seek values of the given table and column.
subroutine whatisseek(tab)
  use dal

  type(TableT), intent(in) :: tab

  type(ColumnT) :: col

  write(*,*) from( tab ), count( tab )

  col = column(tab,"x",MODIFY)
  write(*,*) from( col ), count( col )

end subroutine whatisseek

program example_seek

  use dal

  implicit none

  type(DataSetT) :: set
  type(TableT) :: tab
  type(ColumnT) :: col

  interface
    subroutine whatisseek( subtab )
      use dal
      implicit none
      type(TableT), intent(in) :: subtab
    end subroutine whatisseek
  end interface

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"events",10)
  col = addColumn(tab,"x",real32,"mm")

  call forEachSubTable(tab,whatisseek)

  call release(set)

end program example_seek
