#include <string>

typedef short int16;
typedef double real64;

template<class T> sqr(const T& a) { return a*a; }

class DataSet;
class Table;

class Dal {

  public:

    enum AccessMode { Read, Modify, Create };
};

class DataServer : public Dal {

  public:

    DataSet* open(const std::string&, AccessMode);
};

class DataSet : public Dal {

  public:

    Table* table(const std::string&, AccessMode);
};

class Table : public Dal {};

class Column : public Dal {};

class ColumnData {

  public:

    int16* int16Data();
    real64* real64Data();
};

class SubTable : public Dal {

  public:

    SubTable();

    SubTable(Table*);

    ColumnData* addColumn(const std::string&, AccessMode);

    unsigned long count() const;

    bool next();

    void seek(unsigned long, unsigned long);
};

class TableProcessor : public SubTable {

  public:

    void process(Table*);
};

extern DataServer *dataSetServer;
