module dal

  use daltypes

  integer, parameter :: READ = 10
  integer, parameter :: CREATE = 11
  integer, parameter :: MODIFY = 12

contains

  function int16Data(colData)
    type(ColumnDataT), intent(in) :: colData
    integer(kind=int16), dimension(:), pointer :: int16Data
  end function

  function real64Data(colData)
    type(ColumnDataT), intent(in) :: colData
    real(kind=double), dimension(:), pointer :: real64Data
  end function

  function dataSet(name,mode)
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(DataSetT) dataSet
  end function

  function table(set,name,mode)
    type(DataSetT), intent(in) :: set
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(TableT) table
  end function

  function subTable(tab)
    type(TableT), intent(in) :: tab
    type(SubTableT) subTable
  end function

  function addColumn(subtab,col,mode)
    type(SubTableT), intent(in) :: subtab
    character(len=*), intent(in) :: col
    integer, intent(in) :: mode
    type(ColumnDataT) addColumn
  end function

  function next(subtab)
    type(SubTableT), intent(in) :: subtab
    logical next
  end function

end module dal
