#include <dal.h>
#include <stdio.h>
#include <math.h>

int main()
{
  DataSet *set;
  Table *tab;
  SubTable *st;
  ColumnData *xData, *yData, *rData;
  int16 *x, *y;
  real64 *r;
  unsigned i;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  st = subTable(tab);
  xData = subTableAddColumn(st,"x",READ);
  yData = subTableAddColumn(st,"y",READ);
  rData = subTableAddColumn(st,"r",CREATE);

  subTableSeek(st,10,20);
  x = int16Data(xData);
  y = int16Data(yData);
  r = real64Data(rData);
  for (i = 0; i < 10; ++i) {
    printf("%hd %hd\n", x[i], y[i]);
    r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
  }

  subTableRelease(st);
  dataSetRelease(set);

  return 0;
}
