#include <dal.h>
#include <stdio.h>
#include <math.h>

int main()
{
  DataSet *set;
  Table *tab;
  Column *xCol, *yCol, *rCol;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  xCol = column(tab,"x",READ);
  yCol = column(tab,"y",READ);
  rCol = column(tab,"r",CREATE);

  while (tableNext(tab)) {
    unsigned int i;
    int16 *x, *y;
    real64 *r;

    x = int16Data(xCol);
    y = int16Data(yCol);
    r = real64Data(rCol);

    for (i = 0; i < tableCount(tab); ++i) {
      printf("%hd %hd\n", x[i], y[i]);
      r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
    }
  }

  dataSetRelease(set);

  return 0;
}

