using namespace std;
#include <Dal.h>
#include <iostream>
#include <cmath>

int main()
{
  DataSet* set = dataSetServer->open("test.dat",
	DataSet::Modify);
  Table* tab = set->table("events",Table::Modify);

  ColumnData *xData =
	tab->column("x",Column::Read)->data();
  ColumnData *yData =
	tab->column("y",Column::Read)->data();
  ColumnData *rData =
	tab->column("r",Column::Create)->data();

  tab->seek(10,20);

  int16*  x = xData->int16Data();
  int16*  y = yData->int16Data();
  real64* r = rData->real64Data();
  for (unsigned i = 0; i < tab->count(); ++i) {
    clog << x[i] << ' ' << y[i] << endl;
    r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
  }

  delete set;

  return 0;
}

