/*************************************************************** 
* 
* DalArrayData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Array Data.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalArrayData.h,v 1.2 2002/09/06 14:57:37 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef DAL_ARRAY_DATA_H
#define DAL_ARRAYDATA_H


#include <Dal.h>

#include "DalSeekable.h"
#include "DalChild.h"


class DalArrayData : public virtual ArrayData, public DalSeekable< longVec >, public DalChild<Array>
{
	public :

		DalArrayData(
			const Array *			parent,
			const longVec&			from,
			const longVec&			count );

    		unsigned long position( const longVec& pos ) const;

		virtual ~DalArrayData() {}
};


#endif


