/*************************************************************** 
* 
* DalBlock.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a Block.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalBlock.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef __DAL_BLOCK_H
#define __DAL_BLOCK_H


#include "Dal.h"
#include "DalAttributable.h"
#include "DalDataSet.h"


class DalBlock : public virtual Block, public DalAttributable, public DalChild<DataSet>, public DalChild<DalDataSet>
{
	public :

		// Constructors
		DalBlock(
			const std::string &	name,
			Type		type,
			const std::string &	label,
			DalDataSet *	parent );

		virtual ~DalBlock(){}
		virtual DalBlock& operator=( const DalBlock& );

    		Type		type() const;
		unsigned int	blockNumber() const;
    		void		printOn( ostream& os ) const;
		void		rename( const std::string & newName );
		std::string		parseName( const std::string & compoundName ) const;
		std::string		qualifiedName() const;
		//virtual void	releaseAll() {}

	private :

		Type			_type;

};


#endif


