/*************************************************************** 
* 
* DalCellData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Cell Data.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalCellData.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef DAL_CELL_DATA_H
#define DAL_CELL_DATA_H


#include <Dal.h>

#include "DalSeekable.h"
#include "DalChild.h"


class DalCellData : public virtual CellData, public DalSeekable<unsigned long>, public DalChild<Column>
{
	public :

		DalCellData(
			const Column *			parent,
			unsigned long			rowNumber,
			unsigned long			from,
			unsigned long			count );

		virtual ~DalCellData(){}
	protected :

		unsigned long	_rowNumber;

};


#endif


