/*************************************************************** 
* 
* DalChild.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a Child object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalChild.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $ 
* 
*****************************************************************/ 
#ifndef DAL_CHILD_H
#define DAL_CHILD_H


#include "Child.h"
#include "Tracer.h"


template<class T>
class DalChild : public virtual Child<T>
{
	public :
		DalChild( const T * parent ) : _parent( parent ) {}
		virtual ~DalChild(){}

		T * parent() { PROC RETURN const_cast<T *>(_parent); }
		const T * parent() const { PROC RETURN _parent; }
		void parent( const T * parent ) { PROC _parent = parent; ENDPROC }
		bool isOrphan() const { PROC RETURN _parent == 0; }

	private :
		const T * _parent;

};


#endif
