/*************************************************************** 
* 
* Dal_Labelled.h              & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Labelled.
* 
* (c) 1998 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalLabelled.h,v 1.2 2002/09/06 14:57:37 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef __DAL_LABELLED_H
#define __DAL_LABELLED_H


#include <Dal.h>

#include "Tracer.h"

class DalLabelled : public virtual Labelled
{
	public :
		DalLabelled( const std::string & name, const std::string & label ) :
				_name( name ), _label( label ) { PROC ENDPROC }
		virtual ~DalLabelled() {}
		const std::string & name() const { PROC RETURN _name; }
		virtual void rename( const std::string & newName ) { PROC _name = newName; ENDPROC }
		const std::string & label() const { PROC RETURN _label; }
		void relabel( const std::string & newLabel ) { PROC _label = newLabel; ENDPROC }

		virtual std::string parseName( const std::string & ) const = 0;

	private :
		std::string	_name;
		std::string	_label;
};


#endif


