/*************************************************************** 
* 
* DalNullable.h          & XMM Science Analysis System (SAS) 
* 
* Class representing a null value.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalNullable.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef NULLABLE_H
#define NULLABLE_H


#include "Dal.h"


class Nvalue;

class DalNullable : public virtual Nullable
{
	public :

		DalNullable( NullType nullType );
		virtual ~DalNullable();
		DalNullable( const Nullable& );
		DalNullable& operator=( const Nullable& );

		bool nullDefined() const;
		NullType nullType() const;
		void nullValue( long value );
		void nullValue( const std::string& value );
		long intNullValue() const;
		const std::string& stringNullValue() const;
		void deleteNullValue();

	private :
		Nvalue * _nvalue;
		void checkOperation( Nullable::NullType nullType ) const;
};


#endif




