/*************************************************************** 
* 
* HiLowTable.h             & XMM Science Analysis System (SAS) 
* 
* Class representing DAL data table.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: HiLowTable.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef HILOW_TABLE_H
#define HILOW_TABLE_H


#include "Dal.h"
#include "DalTable.h"


class HiLowTable : public DalTable
{

	public :

		HiLowTable(
			const std::string &	name,
			unsigned long	rows,
			const std::string &	label,
			DalDataSet *	parent );

		HiLowTable(
			const Table & 	original,
			DalDataSet * 	parent,
			std::string 		newName = "" );

		virtual ~HiLowTable();

		DalTable& operator=( const Table& );
		void forEachSubTable( void(*callThisFunction)( Table * table ));
		//void seek( unsigned long from, unsigned long count );
		//void releaseAll();

	private :

		// Forbid
		HiLowTable(const HiLowTable&);

		DalColumn * makeColumn(
				const std::string &			name,
				Data::DataType			dataType,
				const std::string &			label,
				const std::string &			units,
				const longVec &			size,
				DalTable *			parent );

};


#endif
