/*************************************************************** 
* 
* MemArrayData.h             & XMM Science Analysis System (SAS) 
* 
* Class representing array data object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemArrayData.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_ARRAY_DATA_H
#define MEM_ARRAY_DATA_H

#include <Dal.h>

#include "MemData.h"
#include "DataStorage.h"
#include "DalArrayData.h"
#include "DalArray.h"


class MemArrayData : public DalArrayData, public MemData<DalArray>
{
	public :

		MemArrayData(
			DataStorage *			data,
			const DalArray *		parent,
			const longVec&			from,
			const longVec&			count,
			AccessMode			accessMode );

		virtual ~MemArrayData();

		unsigned long elements() const;
		const longVec& size() const;

		void seek(
			const longVec & from,
			const longVec & count );

};

#endif
