/*************************************************************** 
* 
* MemColumnData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing the Data in a Column. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemColumnData.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_COLUMN_DATA
#define MEM_COLUMN_DATA


#include <Dal.h>

#include "MemData.h"
#include "DataStorage.h"
#include "DalColumnData.h"
#include "DalColumn.h"


class MemColumnData : public DalColumnData, public MemData<DalColumn>
{
	public :

		MemColumnData(
			DataStorage *			data,
			const DalColumn *		parent,
			unsigned long			from,
			unsigned long			count,
			AccessMode			accessMode );

		virtual  ~MemColumnData();

    		unsigned long position(
				unsigned long			row) const;

    		unsigned long position(
				unsigned long			row,
				unsigned long		 	pos) const;

    		unsigned long position(
				unsigned long			row,
				const vector<unsigned long>& 	pos) const;

		unsigned long elements() const;
		const vector<unsigned long>& size() const;

		void seek( unsigned long from, unsigned long count );

};


#endif


