/*************************************************************** 
* 
* MemDataSet.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a DAL Data Set.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemDataSet.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_DATA_SET_H
#define MEM_DATA_SET_H


#include "Dal.h"
#include "DalBlock.h"
#include "DalLabelled.h"
#include "DalDataSet.h"
#include "DataSetReaderWriter.h"


class MemDataSet : public DalDataSet
{
	public :

		// Constructors
		MemDataSet(
				const std::string &			setName,
				AccessMode			openMode,
				DalDataSetServer *              server,
				DataSetReaderWriter*		readerWriter );

		MemDataSet( const MemDataSet & );
		//DalDataSet& operator=( const DalDataSet & );
	
		DalTable * makeTable(
			const std::string &		name,
			const std::string &		label,
			unsigned long		rows,
			DalDataSet *		parent );

		DalArray * makeArray(
			const std::string &			name,
			DataType			dataType,
			const longVec&			size,
			const std::string &			units,
			const std::string &			label,
			DalDataSet *			parent );

		virtual ~MemDataSet();

		void		printOn( ostream & os ) const;

	private :

		void readmodify();
		void create();
		void temp();
};


#endif
