/*************************************************************** 
* 
* MemTable.h             & XMM Science Analysis System (SAS) 
* 
* Class representing DAL data table.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemTable.h,v 1.2 2002/09/06 14:57:37 gvacanti Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_TABLE_H
#define MEM_TABLE_H

#include "Dal.h"
#include "DalTable.h"


class MemTable : public DalTable
{


	public :

		MemTable(
			const std::string &	name,
			unsigned long	rows,
			const std::string &	label,
			DalDataSet *	parent );

		//DalTable * makeTable(
		//	const std::string &	name,
		//	unsigned long	rows,
		//	const std::string &	label,
		//	DalDataSet *	parent );

		MemTable(
			const Table & 	original,
			DalDataSet * 	parent,
			const std::string &	newName = "" );

		virtual ~MemTable();

		DalTable& operator=( const Table& );

		void forEachSubTable( void(*callThisFunction)( Table * table ));

	private :

		// Forbid
		MemTable(const MemTable&);

		DalColumn * makeColumn(
				const std::string &			name,
				Data::DataType			dataType,
				const std::string &			label,
				const std::string &			units,
				const longVec &	size,
				DalTable *			parent );

};


#endif
