using namespace std;

#include "HiLowDalDatabase.h"
#include "Tracer.h"


HiLowDalDatabase::HiLowDalDatabase()
{
	PROC
	unlock();
	ENDPROC
}


void
HiLowDalDatabase::addEntry( const DataSet & /* dataSet */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::addEntry( const Block & block )
{
	PROC
	if( locked() )
	{
		ALTRETURN;
	} // if

	switch( block.type() )
	{
		case Block::TableT :
		{
			const Table * table = block.parent()->table(block.name());
			addEntry( *table );
		}
			break;
		case Block::ArrayT :
		{
			const Array * array = block.parent()->array(block.name());
			addEntry( *array );
		}
			break;
		default :
			errstr << "the block " << block.name() << " has an invalid type " << int( block.type() ) << Sas::error("internalError");
			break;
	} // switch

	ENDPROC
}


void
HiLowDalDatabase::addEntry( const Table & /* table */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::addEntry( const Array & /* array */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::addEntry( const Column & /* column */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::setVariableColumnSize( const CellData & /* cellData */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::deleteEntry( const DataSet & /* dataSet */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::deleteEntry( const Block & block )
{
	PROC
	if( locked() )
	{
		ALTRETURN;
	} // if

	switch( block.type() )
	{
		case Block::TableT :
		{
			const Table * table = block.parent()->table(block.name());
			deleteEntry( *table );
		}
			break;
		case Block::ArrayT :
		{
			const Array * array = block.parent()->array(block.name());
			deleteEntry( *array );
		}
			break;
		default :
			errstr << "the block " << block.name() << " has an invalid type " << int( block.type() ) << Sas::error("internalError");
			break;
	} // switch

	ENDPROC
}


void
HiLowDalDatabase::deleteEntry( const Table & /* table */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::deleteEntry( const Array & /* array */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


void
HiLowDalDatabase::deleteEntry( const Column & /* column */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	ENDPROC
}


bool
HiLowDalDatabase::hasEntry( const DataSet & /* dataSet */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	RETURN true;
}


bool
HiLowDalDatabase::hasEntry( const Block & block )
{
	PROC
	if( locked() )
	{
		RETURN true;
	} // if

	switch( block.type() )
	{
		case Block::TableT :
		{
			const Table * table = block.parent()->table(block.name());
			hasEntry( *table );
		}
			break;
		case Block::ArrayT :
		{
			const Array * array = block.parent()->array(block.name());
			hasEntry( *array );
		}
			break;
		default :
			errstr << "the block " << block.name() << " has an invalid type " << int( block.type() ) << Sas::error("internalError");
			break;
	} // switch

	RETURN true;
}


bool
HiLowDalDatabase::hasEntry( const Table & /* table */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	RETURN true;
}


bool
HiLowDalDatabase::hasEntry( const Array & /* array */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	RETURN true;
}


bool
HiLowDalDatabase::hasEntry( const Column & /* column */ )
{
	PROC
	if( !locked() )
	{
		// TODO
	} // if
	RETURN true;
}


void
HiLowDalDatabase::insertRows(
		const Table &	table,
		unsigned long	pos,
		unsigned long	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << Sas::error( "NotImplemented" ) << table.name() << pos << count;
	ENDPROC
}


void
HiLowDalDatabase::deleteRows(
		const Table &	table,
		unsigned long	from,
		unsigned long	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << Sas::error( "NotImplemented" ) << table.name() << from << count;
	ENDPROC
}


void
HiLowDalDatabase::copyRows(
		const Column &	column,
		unsigned long	from,
		unsigned long	to,
		unsigned long	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << Sas::error( "NotImplemented" ) << column.name() << from << to << count;
	ENDPROC
}


void 
HiLowDalDatabase::dumpData(
		const Column & 	column,
		char ** 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void 
HiLowDalDatabase::dumpData(
		const Column & 	column,
		bool8 *		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void 
HiLowDalDatabase::dumpData(
		const Column & 	column,
		int8 * 		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		uint16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		int16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		uint32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		int32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		real32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		real64 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		char **		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		bool8 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		int8 * 		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		uint16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		int16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		uint32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		int32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		real32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		real64 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}



void 
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		char ** 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void 
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		bool8 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void 
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		int8 * 		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		uint16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		int16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		uint32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		int32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		real32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Column & 	column,
		unsigned long	rowNumber,
		real64 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		char **		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		bool8 *		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		int8 * 		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		uint16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		int16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		uint32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		int32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		real32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Column & 	column,
		unsigned long	rowNumber,
		real64 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << column.name() << rowNumber << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array, 
		char ** 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array, 
		bool8 *		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array, 
		int8 * 		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array,
		uint16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array,
		int16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array,
		uint32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array,
		int32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array,
		real32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::dumpData(
		const Array & 	array,
		real64 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		char ** 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		bool8 *		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		int8 * 		values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		uint16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		int16 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		uint32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		int32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array & 	array,
		real32 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}


void
HiLowDalDatabase::loadData(
		const Array &	array,
		real64 * 	values,
		unsigned long 	from,
		unsigned long 	count )
{
	PROC
		// TODO
	errstr << "Not implemented" << array.name() << values << from << count << Sas::error( "NotImplemented" );
	ENDPROC
}



