/*************************************************************** 
* 
* HiLowFitsReaderWriter.h     & XMM Science Analysis System (SAS) 
* 
* Class representing FITS file reader/writer.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: HiLowFitsReaderWriter.h,v 1.2 2002/09/06 14:57:38 gvacanti Exp $
* 
*****************************************************************/ 
#ifndef HILOW_FITS_READER_WRITER_H
#define HILOW_FITS_READER_WRITER_H


#include "FitsReaderWriter.h"
#include "HiLowFitsDatabase.h"


class HiLowFitsReaderWriter : public virtual FitsReaderWriter, public virtual HiLowFitsDatabase
{
	public :

		HiLowFitsReaderWriter();
	virtual ~HiLowFitsReaderWriter() {}
		void read( DataSet* dataSet );
		void write( DataSet* dataSet );

	private :

		int writeColumns(
			fitsfile *	fptr,
			const Table &	table,
			int &		status ) const;

		int writeTable( 
			fitsfile *	fptr,
			const Table &	table,
			int &		status ) const;

		//int readColumn(
		//	fitsfile *	fptr,
		//	int &		columnNumber,
		//	Table &		table,
		//	int &		status ) const;

		int readTable(
			fitsfile * 	fptr,
			DataSet &	dataSet,
			int &		status ) const;

		int readArray(
			fitsfile *	fptr,
			DataSet &	dataSet,
			int &		status ) const;

		int readPrimaryArray(
			fitsfile *		fptr,
			DataSet &		dataSet,
			KeywordChecker *	keywordChecker,
			int &			status ) const;

		int writeArray(
			fitsfile *	fptr,
			const Array &	array,
			int &		status ) const;

		int deleteProcessHistory(
			fitsfile *	fptr,
			int &		status ) const;

		int deleteUnwantedKeyword(
			fitsfile *	fptr,
			const std::string&	keyword,
			int &		status ) const;

		int deleteAttributes(
			fitsfile *	fptr,
			int &		status ) const;
		//int deletePrimaryHeaderAttributes(
		//	fitsfile *	fptr,
		//	int &		status ) const;

		//int deleteCommentsAndHistory(
		//	fitsfile *		fptr,
		//	KeywordChecker *	attributeChecker,
		//	int &			status ) const;
		int deleteCommentsAndHistory(
			fitsfile *		fptr,
			int &			status ) const;

};


#endif
