/*************************************************************** 
* 
* MemFitsFileReaderWriter.h     & XMM Science Analysis System (SAS) 
* 
* Class representing FITS file reader/writer.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemFitsReaderWriter.h,v 1.1.1.1 2002/08/30 13:06:29 gvacanti Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_FITS_FILE_READER_WRITER_H
#define MEM_FITS_FILE_READER_WRITER_H


#include "FitsReaderWriter.h"
#include "MemFitsDatabase.h"


class MemFitsReaderWriter : public virtual FitsReaderWriter, public virtual MemFitsDatabase
{
	public :

		//MemFitsReaderWriter();
		virtual ~MemFitsReaderWriter(){}

		void read( DataSet* dataSet );
		void write( DataSet* dataSet );

	private :
		int writeColumns(
			fitsfile *	fptr,
			const Table &	table,
			int &		status ) const;

		int writeTable( 
			fitsfile *	fptr,
			const Table &	table,
			int &		status ) const;

		//virtual int readColumn(
		//	fitsfile *	fptr,
		//	int &		columnNumber,
		//	Table &		table,
		//	int &		status ) const;

		int readTable(
			fitsfile * 	fptr,
			DataSet &	dataSet,
			int &		status ) const;

		int readArray(
			fitsfile *	fptr,
			DataSet &	dataSet,
			int &		status ) const;

		int readPrimaryArray(
			fitsfile *		fptr,
			DataSet &		dataSet,
			KeywordChecker *	keywordChecker,
			int &			status ) const;

		int writeArray(
			fitsfile *	fptr,
			const Array &	array,
			int &		status ) const;

	protected :

		int readVariableLengthColumnData(
			fitsfile *	fptr,
			Column *	column,
			int &		columnNumber,
			int &		status ) const;

		int readFixedLengthColumnData(
			fitsfile *	fptr,
			Column *	column,
			int &		columnNumber,
			int &		status ) const;

};



#endif
