using namespace std;
#include <Dal.h>
#include <errstr.h>

int main()
{
  DataSet *set = dataSetServer->open("test.dat",DataSet::Read);

  unsigned long size[] = { 5,7,3,5,4,6 };
  unsigned long nullSize[] = { 0,0 };
  unsigned long size1 = size[0], size2 = size1*size[1], size3 = size2*size[2];

  Array* arr;
  Data* data;

  arr = set->array("PRIMARY");
  assert( arr -> attributes() == 2 );
  assert( arr -> attribute(0) -> name() == "ATT1" );
  assert( arr -> attribute(1) -> name() == "ATT2" );
  assert( arr->dataType() ==  Array::Int8 );
  assert( arr->size() == vector<unsigned long>(nullSize,nullSize+1) );
  assert( arr->elements() == 0 );
  //data = arr->data();
  //int8* i8 = data->int8Data();
  //delete data;

  arr = set->array("int8Array");
  assert( arr->dataType() ==  Array::Int8 );
  assert( arr->size() == vector<unsigned long>(size,size+3) );
  assert( arr->elements() == size3 );
  data = arr->data();
  int8* i8 = data->int8Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( i8[i] == int(i%100) );
  delete data;

  arr = set->array("uint16Array");
  assert( arr->dataType() == Array::Uint16 );
  assert( arr->size() == vector<unsigned long>(size,size+1) );
  assert( arr->elements() == size1 );
  data = arr->data();
  uint16* ui16 = data->uint16Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( ui16[i] == uint16(i) );
  delete data;

  arr = set->array("int16Array");
  assert( arr->dataType() == Array::Int16 );
  assert( arr->size() == vector<unsigned long>(size,size+1) );
  assert( arr->elements() == size1 );
  data = arr->data();
  int16* i16 = data->int16Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( i16[i] == int(i) );
  delete data;

  arr = set->array("uint32Array");
  assert( arr->dataType() == Array::Uint32 );
  assert( arr->size() == vector<unsigned long>(size,size+2) );
  assert( arr->elements() == size2 );
  data = arr->data();
  uint32* ui32 = data->uint32Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( ui32[i] == uint32(i) );
  delete data;

  arr = set->array("int32Array");
  assert( arr->dataType() == Array::Int32 );
  assert( arr->size() == vector<unsigned long>(size,size+2) );
  assert( arr->elements() == size2 );
  data = arr->data();
  int32* i32 = data->int32Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( i32[i] == int(i) );
  delete data;

  arr = set->array("real32Array");
  assert( arr->dataType() == Array::Real32 );
  assert( arr->size() == vector<unsigned long>(size,size+3) );
  assert( arr->elements() == size3 );
  data = arr->data();
  real32* r32 = data->real32Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( r32[i] == 0.5*i );
  delete data;

  arr = set->array("real64Array");
  assert( arr->dataType() == Array::Real64 );
  assert( arr->size() == vector<unsigned long>(size,size+1) );
  assert( arr->elements() == size1 );
  data = arr->data();
  real64* r64 = data->real64Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( r64[i] == 0.25*i );
  delete data;

/* String arrays are not supported.
  arr = set->array("stringArray");
  assert( arr->dataType() == Array::DString );
  assert( arr->size() == vector<unsigned long>(size,size+2) );
  assert( arr->elements() == size2 );
  data = arr->data();
  string* s = data->stringData();
  for (unsigned i = 0; i < data->elements(); ++i) {
    stringstream ss;
    ss << "string" << i;
    assert( s[i] == ss.str() );
  }
  delete data;
*/

  dataSetServer->close(set);

  return 0;
}

