using namespace std;

#include <Dal.h>
#include <iostream>


int
main()
{
  DataSet* set = dataSetServer->open("test.dat",DataSet::Create);
  set -> addComment( "first comment" );
  set -> addComment( "" );
  set -> addComment( " " );
  set -> addComment( "  " );
  set -> addComment( "   " );
  set -> addComment( "    " );
  set -> addComment( "third comment" );
  set -> addComment( "fourth comment" );
  set -> addComment( "" );
  set -> addComment( "fifth comment" );
  set -> addComment( "sixth comment" );
  assert( set -> comments() == 11 );
  assert( set -> comment( 0 ) == "first comment" );
  assert( set -> comment( 1 ) == "" );
  assert( set -> comment( 2 ) == " " );
  assert( set -> comment( 3 ) == "  " );
  assert( set -> comment( 4 ) == "   " );
  assert( set -> comment( 5 ) == "    " );
  assert( set -> comment( 6 ) == "third comment" );
  assert( set -> comment( 7 ) == "fourth comment" );
  assert( set -> comment( 8 ) == "" );
  assert( set -> comment( 9 ) == "fifth comment" );
  assert( set -> comment( 10 ) == "sixth comment" );
  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Read);
  cout << "no.comments = " << set -> comments() << endl;
  assert( set -> comments() == 11 );
  assert( set -> comment( 0 ) == "first comment" );
  assert( set -> comment( 1 ) == "" );
  assert( set -> comment( 2 ) == "" );
  assert( set -> comment( 3 ) == "" );
  assert( set -> comment( 4 ) == "" );
  assert( set -> comment( 5 ) == "" );
  assert( set -> comment( 6 ) == "third comment" );
  assert( set -> comment( 7 ) == "fourth comment" );
  assert( set -> comment( 8 ) == "" );
  assert( set -> comment( 9 ) == "fifth comment" );
  assert( set -> comment( 10 ) == "sixth comment" );
  dataSetServer->close(set);

  return 0;
}
