using namespace std;


#include "Tracer.h"
#include "Dal.h"


static void fill( Column* col )
{
	PROC
	for( unsigned int i = 0; i < col -> rows(); ++i )
	{
  		ColumnData* cd = col -> rowData( i, Dal::AsParent );
	  	int32 *i32 = cd -> int32Data();
  		for( unsigned long j = 0; j < cd -> elements(); ++j )
		{
    			i32[ j ] = 3 * i + j;
		}
  		delete cd;
	} // if
	ENDPROC
}


static void check( Column* col )
{
	PROC
	for( unsigned int i = 0; i < col -> rows(); ++i )
	{
  		ColumnData* cd = col -> rowData( i, Dal::AsParent );
	  	int32 *i32 = cd -> int32Data();
  		for( unsigned long j = 0; j < cd -> elements(); ++j )
		{
    			assert( i32[ j ] == int32( 3 * i + j ) );
		}
  		delete cd;
	} // if
	ENDPROC
}


int
main()
{
	PROC


  	DataSet* set = dataSetServer->open("test.dat", DataSet::Create);
  	Table* table = set->addTable("FIRST", 100 );

  	Column* col = table->addColumn("VAR", 
				  Column::Int32, 
				  "No comment", 
				  "", 
				  Dal::zero);

	for( unsigned int i = 0; i < col -> rows(); ++i )
	{
		CellData* cd = col -> cellData( i );
		cd -> size( i + 1 );
		delete cd;
	} // for
	fill( col );
	check( col );

	col = table -> addColumn( "FIX", Column::Int32,"int32 data","dm" );
	fill( col );
	check( col );
	dataSetServer -> close( set );

  	set = dataSetServer->open("test.dat", DataSet::Read);
  	table = set->table("FIRST");
	col = table -> column("VAR");
	check(col);
	col = table -> column( "FIX" );
	check( col );
	dataSetServer -> close( set );

	ENDPROC
}
