
program test

  use dal
  use errorHandling
  implicit none

  type(DataSetT) :: set1, set2
  type(TableT) :: tab1, tab2
  type(ArrayT) :: arr1, arr2

  set1 = dataSet("test1.dat",create)
  call setAttribute(set1,"sbool",.false.,"set bool comment")
  tab1 = addTable(set1,"table",create)
  call setAttribute(tab1,"tint",3,"table int comment")
  call release( set1 );

  set1 = dataSet("test1.dat",read)
  tab1 = table(set1,"table")
  set2 = dataSet("test2.dat",create)
  tab2 = addTable(set2,"table",create)
  call setAttribute( set2, attribute( set1, "sbool" ))
  call setAttribute( set2, attribute( tab1, "tint" ))
  call setAttribute( tab2, attribute( set1, "sbool" ))
  call setAttribute( tab2, attribute( tab1, "tint" ))
  call release( set1 );
  call release( set2 );

  set2 = dataSet("test2.dat",read)
  tab2 = table(set2,"table")
  if ( booleanAttribute(set2,"sbool") ) &
	call error("testFailed","set bool value")
  if ( int16Attribute(set2,"tint") /= 3 ) &
	call error("testFailed","set int value")
  if ( booleanAttribute(tab2,"sbool") ) &
	call error("testFailed","tab bool value")
  if ( int16Attribute(tab2,"tint") /= 3 ) &
	call error("testFailed","tab int value")
  call release( set2 );
 
end program test
