program arraytestcheck

  use dal
  use errorHandling

  implicit none

  type(DataSetT) :: set
  type(ArrayT) :: arr
  integer(kind=int32), dimension(:,:), pointer :: a

  set = dataSet("test.dat",read)

  arr = array(set,0,read)

  a => int32Array2Data(arr)

  write(*,*) shape(a)
  write(*,*) a

  if ( any(shape(a) /= (/ 2,3 /)) ) then
    write(errstr,*) "shape",shape(a),"but expected 2,3"
    call error("internalError")
  end if

  if ( a(0,0) /= 1 .or. a(1,0) /= 2 .or. a(0,1) /= 3 &
    .or. a(1,1) /= 4 .or. a(0,2) /= 5 .or. a(1,2) /= 6) &
    call error("internalError","value wrong")

  call release(set)

end program
