using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// October 2001
//
#include<Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<errstr.h>
#include<vector>

int main() {

  ExceptionErrorHandler thrower;
  errHandler.handler(&thrower);

  std::vector<std::string> tables;
  tables.push_back("set.ds");
  tables.push_back("set1.ds");


  size_t k = 0;
  DataSet * set =  dataSetServer->open(tables[k], Dal::Create);
  
  try {
    set->table(tables[k]);
  }
  // I rely on a specific string to be in the error message
  catch(SasException::Exception e){
    std::cout << "Failed with " << e.message << std::endl;
    assert(e.message.find("Most likely you failed to specify append a ':' to") !=
	   std::string::npos);
    std::cout << "Failed as expected with " << e.message << std::endl;    
    
    dataSetServer->close(set);
    exit(0);
  }
  exit(1);
}
