//
// $Id: spr2289.cc,v 1.1.1.1 2002/08/30 12:55:13 gvacanti Exp $
//
#include<Dal.h>
#include <errstr.h>
#include<cassert>

// This is supposed to run after spr2289f90


using namespace std;

int main() {
  DataSet * set = dataSetServer->open("spr2289f90_in.ds", Dal::Modify);
  Table * tab = set->table("table");
  tab->seek(10, 10);
  Column * col = tab->column("column");
  ColumnData * cd = col->data();
  cd->setToNull(5);
  delete cd;
  dataSetServer->close(set);

  set = dataSetServer->open("spr2289f90_in.ds", Dal::Read);
  tab = set->table("table");
  col = tab->column("column");
  cd = col->data();

  // The following shows that SPR 2289 is confined to fortran

  assert(cd->isNull(15));

  // This catches (again) if the test spr2289f90 has failed
  if(cd->isNull(5))
    Sas::error("UnexpectedNull",
	       "I did not expect to see a NULL at element 5");

  delete cd;
  dataSetServer->close(set);

}
  
