//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// $Id: spr2343.cc,v 1.1 2002/09/06 14:31:46 gvacanti Exp $
//
#include<Dal.h>
#include<errstr.h>
#include <ExceptionErrorHandler.h>  
#include<iostream>
#include<Tracer.h>
#include<cmath>
#include<cassert>

int main()
{
    
    // One needs this file to see the problem (pure virtual method called).
    // If one creates a separate file the problem is different. (See below.)
    std::string set1("spr2343.set");
    DataSet * s1;
    Table * t;
 

    unsigned long from = 0;
    unsigned long to = 0;
    unsigned long count = 1;
    
    s1 = dataSetServer->open(set1, Dal::Modify);
    t = s1->table(0);
    t->copyRows(from, to, count);
    
    dataSetServer->close(s1);


    // In general copying rows from from == to corrupts the data
    // because these are overwritten with random garbage.

    set1 = "spr2343bis.ds";

    s1 = dataSetServer->open(set1, Dal::Create);
    t = s1->addTable("table", 1);
    Column * c = t->addColumn("column",Dal::Int16,"","",Dal::zero);
    CellData *d = c->cellData(0);
    d->size(3);
    int16 * v = d->int16Data();
    v[0] = v[1] = v[2] = 3;
    delete d;

    t->copyRows(from, to, count);
    // At this stage any pointers are not guaranteed to be valid.

    dataSetServer->close(s1);
  
    s1 = dataSetServer->open(set1, Dal::Modify);
    t = s1->table(0);

    c = t->column("column");
    d = c->cellData(0);
    v = d->int16Data();


    assert(v[0] == 3 && v[1] == 3 && v[2] == 3);

    dataSetServer->close(s1);

    
}
