using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// September 2001
//


#include<Dal.h>
#include<iostream>
#include<cassert>

#include<cstdlib>
#include<cstring>
#include<fitsio.h>
#include<longnam.h>

int main()
{


  // show that with cfitsio it is possible to insert rows in a table
  // with variable length vector columns. 
  {
    int N = 10;
    int *arr, i;
    int status = 0;
    fitsfile *fptr;
    char *ttype1[] = { "Ivalue", };
    char *tform1[] = { "1PJ", };
    char *tunit1[] = { "s", };
    char name1[] = "X1";
    arr = static_cast<int *>(malloc(N*sizeof(int)));
    for (i=0; i<N; ++i)
      arr[i] = i;
    fits_create_file(&fptr, "!cfits.ds", &status);
    printf("%d", status);
    fits_create_tbl(fptr, BINARY_TBL, 0, 1, ttype1, tform1, tunit1,
		    name1, &status);

    fits_write_col(fptr, TINT, 1, 1, 1, N, arr, &status);
    fits_insert_rows(fptr, 1, 10, &status);

    fits_close_file(fptr, &status);        
    printf("%d\n", status);

    fits_open_file(&fptr, "cfits.ds", READWRITE, &status);
    printf("%d", status);
    fits_movnam_hdu(fptr, ANY_HDU, name1, 0, &status);
    printf("%d", status);
    fits_insert_rows(fptr, 0, 10, &status);
    printf("%d", status);
    fits_close_file(fptr, &status);        
    printf("%d\n", status);

    assert(status == 0);

  }

  // check that the dal understands the output of cfitsio
  {
    unsigned long N = 10;
    DataSet * set = dataSetServer->open("cfits.ds:X1:Ivalue", Dal::Read);
    Table * tab = set->table("cfits.ds:X1:Ivalue");
    Column * col = tab->column("cfits.ds:X1:Ivalue");

    assert(tab->rows() == 21);
    for(size_t k = 0; k < tab->rows(); ++k){
      CellData * cd = col->cellData(k);
      std::cout << "row = " << k << " size = " << cd->size() << std::endl;
      k == 10 ?
	assert(cd->size() == N)
	: assert(cd->size() == 0);
      delete cd;
    }
    dataSetServer->close(set);
  }
    
}

  
